/************************************************************************

 The contents of this file are subject to the Mozilla Public License
 Version 1.1 (the "License"); you may not use this file except in	
 compliance with the License. You may obtain a copy of the License at
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS"
 basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 License for the specific language governing rights and limitations
 under the License.

 The Original Code is Isearch.

 The Initial Developer of the Original Code is Clearinghouse for
 Networked Information Discovery and Retrieval.

 Portions created by Netscape Communications are Copyright (C) 2001. 
 All Rights Reserved.

 Portions created by the Clearinghouse for Networked Information
 Discovery and Retrieval are Copyright (C) 1994. All Rights Reserved.

************************************************************************/

/* General definitions */

#ifndef DEFS_H
#define DEFS_H

#include <unistd.h>
#include "gdt.h"

#define FIELD_MASK  0xFF000000
#define FILEID_MASK 0x00FFFFFF

// the maximum number of results to return
#define MAX_RESULT_ENTRIES 100000

// ( for NewHoo search /gh/searchDB/1/tree/ => 5 )
#define CATEGORY_DIR_DEPTH 5

extern const CHR* IsearchDefaultDbName;
extern const CHR* IsearchVersion;
extern const CHR* DbExtIndex;
extern const CHR* DbExtMdt;

typedef UINT4 GPTYPE;
typedef GPTYPE* PGPTYPE;

typedef struct INDEX_ENTRY {
    GPTYPE gpindex;           // global possition index of a word
    GPTYPE mdtindex;          // multiple document table index of a word 
} index_entry;

const INT StringCompLength = 32;   // default=32 how many characters to compare

const INT IndexingStatusParsingDocument = 1;
const INT IndexingStatusIndexing = 2;
const INT IndexingStatusMerging = 3;
const INT IndexingStatusParsingFiles = 4;

// Operand Types
const INT TypeTerm = 1;
const INT TypeRset = 2;

#define COUT cout

#endif
